function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

/* eslint-disable react-hooks/exhaustive-deps */
import React, { useState, useEffect } from "react";
import { Controlled as CodeMirror } from "react-codemirror2";
import { useDispatch, useSelector } from "react-redux";
import "codemirror/lib/codemirror.css";
import { ignoreError } from "../../utilities/error";
import FileList from "../file-list/FileList";
import { init, edit } from "../../store/fileSlice";
import * as __styles from "./Editor.module.css";
var styles = __styles["default"] ? __styles["default"] : __styles;

function CustomizableEditor(_ref) {
  var code = _ref.code,
      currentFile = _ref.currentFile,
      theme = _ref.theme,
      keyMap = _ref.keyMap,
      storageKey = _ref.storageKey,
      runCode = _ref.runCode;
  var app = code.app,
      files = code.files;

  var _useState = useState(app),
      _useState2 = _slicedToArray(_useState, 2),
      _app = _useState2[0],
      setApp = _useState2[1];

  var _files = useSelector(function (state) {
    return state.files.container;
  });

  var _current = useSelector(function (state) {
    return state.files.current;
  });

  var dispatch = useDispatch();
  var options = {
    mode: {
      name: "jsx",
      json: true
    },
    theme: theme,
    keyMap: keyMap,
    lineNumbers: true,
    lineWrapping: true,
    autoCloseBrackets: true
  };

  var getCurrentCode = function getCurrentCode() {
    if (_current === "App") {
      return _app;
    }

    return _files[_current];
  };

  var editCode = function editCode(_editor, _data, value) {
    if (_current === "App") {
      return setApp(value);
    }

    dispatch(edit(value));
  };

  useEffect(function () {
    window.addEventListener("error", ignoreError);
    dispatch(init({
      container: files,
      current: currentFile
    }));
    return function () {
      return window.removeEventListener("error", ignoreError);
    };
  }, []);
  useEffect(function () {
    runCode({
      files: _files,
      app: _app
    });

    if (storageKey) {
      localStorage["code:".concat(storageKey)] = JSON.stringify({
        app: _app,
        files: _files
      });
    }
  }, [_files, _app]);
  useEffect(function () {
    setApp(app);
    dispatch(init({
      container: files,
      current: currentFile
    }));
  }, [app, files]);
  return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(FileList, null), /*#__PURE__*/React.createElement(CodeMirror, {
    className: styles["codeEditor"],
    value: getCurrentCode(),
    options: options,
    onBeforeChange: editCode
  }));
}

export default CustomizableEditor;