var _excluded = ["viewerId", "codeEditorContext"];

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React, { useEffect, useState } from "react";
import ReactDOM from "react-dom";
import * as Vue from "vue";
import ErrorBoundary from "../error-boundary/ErrorBoundary";
import { TargetFramework } from "../../models/compiler";
import createBundler from "../../utilities/worker";
import "codemirror/mode/jsx/jsx";
import "codemirror/addon/edit/closebrackets";
import "codemirror/keymap/sublime";
import "codemirror/theme/shadowfox.css";
import CustomizableEditor from "./CustomizableEditor";

function VueEditor(_ref) {
  var viewerId = _ref.viewerId,
      _ref$codeEditorContex = _ref.codeEditorContext,
      codeEditorContext = _ref$codeEditorContex === void 0 ? "test" : _ref$codeEditorContex,
      props = _objectWithoutProperties(_ref, _excluded);

  var _useState = useState(),
      _useState2 = _slicedToArray(_useState, 2),
      worker = _useState2[0],
      setWorker = _useState2[1];

  var renderViewer = function renderViewer(node) {
    ReactDOM.render( /*#__PURE__*/React.createElement(ErrorBoundary, null, node), document.getElementById(viewerId));
  };

  var runBundle = function runBundle(bundle) {
    try {
      var runner = new Function("require", bundle);
      var vueElement = runner(function () {
        return null;
      });
      vueElement.mount("#".concat(viewerId));
    } catch (err) {
      renderViewer( /*#__PURE__*/React.createElement("pre", {
        style: {
          color: "red"
        }
      }, err.message));
    }
  };

  var run = function run(code) {
    if (worker) {
      worker.onmessage = function (event) {
        runBundle(event.data);
      };

      worker.onerror = function (err) {
        renderViewer( /*#__PURE__*/React.createElement("pre", {
          style: {
            color: "red"
          }
        }, err.message));
      };

      worker.postMessage({
        code: code,
        context: codeEditorContext,
        target: TargetFramework.VUE
      });
    }
  };

  var loadDependencies = function loadDependencies() {
    // @ts-expect-error: Namespace not supported in TS
    window["vue"] = Vue;
  };

  useEffect(function () {
    loadDependencies();
    var bundler = createBundler();
    setWorker(bundler);
    return function () {
      return bundler.terminate();
    }; // eslint-disable-next-line react-hooks/exhaustive-deps
  }, []);
  return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(CustomizableEditor, _extends({}, props, {
    theme: "shadowfox",
    keyMap: "sublime",
    runCode: run
  })));
}

export default VueEditor;