function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

import React, { useState } from "react";
import { useDispatch, useSelector } from "react-redux";
import { genUniqueName } from "../../utilities/file";
import { remove, rename, view } from "../../store/fileSlice";
import { CloseIcon, DragIndicatorIcon } from "../icons";
import * as __styles from "./FileBlock.module.css";
var styles = __styles["default"] ? __styles["default"] : __styles;
var initialRenameState = {
  name: ""
};
export function StaticFileBlock(_ref) {
  var name = _ref.name,
      style = _ref.style;
  return /*#__PURE__*/React.createElement("div", {
    className: "\n        ".concat(styles["innerContainer"], "\n        ").concat(styles["selected"]),
    style: style
  }, /*#__PURE__*/React.createElement("div", {
    className: styles["filename"]
  }, name + ".js"), /*#__PURE__*/React.createElement("div", {
    className: styles["dragBtn"]
  }, /*#__PURE__*/React.createElement(DragIndicatorIcon, null)), /*#__PURE__*/React.createElement("div", {
    className: styles["closeBtn"]
  }, /*#__PURE__*/React.createElement(CloseIcon, null)));
}
export function InteractiveFileBlock(_ref2) {
  var name = _ref2.name,
      onDrag = _ref2.onDrag,
      onTargeted = _ref2.onTargeted;

  var _useState = useState(initialRenameState),
      _useState2 = _slicedToArray(_useState, 2),
      _rename = _useState2[0],
      setRename = _useState2[1];

  var _files = useSelector(function (state) {
    return state.files.container;
  });

  var _current = useSelector(function (state) {
    return state.files.current;
  });

  var _drag = useSelector(function (state) {
    return state.drag;
  });

  var dispatch = useDispatch();
  var names = ["App"].concat(Object.keys(_files));

  var isDynamic = function isDynamic(name) {
    return name !== "App" && name === _current;
  };

  var isTargeted = function isTargeted(name) {
    return _drag.to === name;
  };

  var removeFile = function removeFile(name) {
    return dispatch(remove(name));
  };

  var viewFile = function viewFile(name) {
    return dispatch(view(name));
  };

  var updateFileState = function updateFileState(name) {
    if (isDynamic(name)) {
      return setRename({
        target: _current,
        name: _current
      });
    }

    viewFile(name);
  };

  var updateNewName = function updateNewName(e) {
    setRename(_objectSpread(_objectSpread({}, _rename), {}, {
      name: e.target.value
    }));
  };

  var finishRename = function finishRename() {
    var name = _rename.name;

    if (name !== _current) {
      name = genUniqueName(names, name);
    }

    setRename(initialRenameState);
    dispatch(rename(name));
  };

  return /*#__PURE__*/React.createElement("div", {
    key: name,
    onMouseOver: name !== "App" && _drag.from ? function () {
      return onTargeted(name);
    } : undefined,
    className: "".concat(styles["innerContainer"]).concat(isTargeted(name) ? " " + styles["targeted"] : "").concat(_current === name ? " " + styles["selected"] : "")
  }, /*#__PURE__*/React.createElement("div", {
    className: styles["filename"],
    onClick: function onClick() {
      return updateFileState(name);
    }
  }, _current === name && _rename.target ? /*#__PURE__*/React.createElement("div", {
    className: styles["renameInputContainer"]
  }, /*#__PURE__*/React.createElement("input", {
    value: _rename.name,
    onChange: updateNewName,
    onBlur: finishRename,
    size: 1,
    type: "text",
    autoFocus: true
  }), /*#__PURE__*/React.createElement("span", {
    "data-value": _rename.name
  }, ".js")) : name + ".js"), name !== "App" && /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("div", {
    className: styles["dragBtn"],
    onMouseDown: isDynamic(name) ? function (event) {
      return onDrag(event, name);
    } : undefined
  }, /*#__PURE__*/React.createElement(DragIndicatorIcon, null)), /*#__PURE__*/React.createElement("div", {
    className: styles["closeBtn"],
    onClick: function onClick() {
      return removeFile(name);
    }
  }, /*#__PURE__*/React.createElement(CloseIcon, null))));
}