import { createSlice } from "@reduxjs/toolkit";
var initialState = {};
var dragSlice = createSlice({
  name: "drag",
  initialState: initialState,
  reducers: {
    reset: function reset(state) {
      delete state.from;
      delete state.to;
    },
    target: function target(state, action) {
      state.to = action.payload;
    },
    select: function select(state, action) {
      state.from = action.payload;
    },
    unselect: function unselect(state) {
      delete state.to;
    },
    untarget: function untarget(state) {
      delete state.to;
    }
  }
});
var _dragSlice$actions = dragSlice.actions,
    reset = _dragSlice$actions.reset,
    target = _dragSlice$actions.target,
    select = _dragSlice$actions.select,
    unselect = _dragSlice$actions.unselect,
    untarget = _dragSlice$actions.untarget;
export { reset, target, select, unselect, untarget };
export default dragSlice.reducer;