"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactCodemirror = require("react-codemirror2");

var _reactRedux = require("react-redux");

require("codemirror/lib/codemirror.css");

var _error = require("../../utilities/error");

var _FileList = _interopRequireDefault(require("../file-list/FileList"));

var _fileSlice = require("../../store/fileSlice");

var __styles = _interopRequireWildcard(require("./Editor.module.css"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var styles = __styles["default"] ? __styles["default"] : __styles;

function CustomizableEditor(_ref) {
  var code = _ref.code,
      currentFile = _ref.currentFile,
      theme = _ref.theme,
      keyMap = _ref.keyMap,
      storageKey = _ref.storageKey,
      runCode = _ref.runCode;
  var app = code.app,
      files = code.files;

  var _useState = (0, _react.useState)(app),
      _useState2 = _slicedToArray(_useState, 2),
      _app = _useState2[0],
      setApp = _useState2[1];

  var _files = (0, _reactRedux.useSelector)(function (state) {
    return state.files.container;
  });

  var _current = (0, _reactRedux.useSelector)(function (state) {
    return state.files.current;
  });

  var dispatch = (0, _reactRedux.useDispatch)();
  var options = {
    mode: {
      name: "jsx",
      json: true
    },
    theme: theme,
    keyMap: keyMap,
    lineNumbers: true,
    lineWrapping: true,
    autoCloseBrackets: true
  };

  var getCurrentCode = function getCurrentCode() {
    if (_current === "App") {
      return _app;
    }

    return _files[_current];
  };

  var editCode = function editCode(_editor, _data, value) {
    if (_current === "App") {
      return setApp(value);
    }

    dispatch((0, _fileSlice.edit)(value));
  };

  (0, _react.useEffect)(function () {
    window.addEventListener("error", _error.ignoreError);
    dispatch((0, _fileSlice.init)({
      container: files,
      current: currentFile
    }));
    return function () {
      return window.removeEventListener("error", _error.ignoreError);
    };
  }, []);
  (0, _react.useEffect)(function () {
    runCode({
      files: _files,
      app: _app
    });

    if (storageKey) {
      localStorage["code:".concat(storageKey)] = JSON.stringify({
        app: _app,
        files: _files
      });
    }
  }, [_files, _app]);
  (0, _react.useEffect)(function () {
    setApp(app);
    dispatch((0, _fileSlice.init)({
      container: files,
      current: currentFile
    }));
  }, [app, files]);
  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(_FileList["default"], null), /*#__PURE__*/_react["default"].createElement(_reactCodemirror.Controlled, {
    className: styles["codeEditor"],
    value: getCurrentCode(),
    options: options,
    onBeforeChange: editCode
  }));
}

var _default = CustomizableEditor;
exports["default"] = _default;
//# sourceMappingURL=CustomizableEditor.js.map
