"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.StaticFileBlock = StaticFileBlock;
exports.InteractiveFileBlock = InteractiveFileBlock;

var _react = _interopRequireWildcard(require("react"));

var _reactRedux = require("react-redux");

var _file = require("../../utilities/file");

var _fileSlice = require("../../store/fileSlice");

var _icons = require("../icons");

var __styles = _interopRequireWildcard(require("./FileBlock.module.css"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var styles = __styles["default"] ? __styles["default"] : __styles;
var initialRenameState = {
  name: ""
};

function StaticFileBlock(_ref) {
  var name = _ref.name,
      style = _ref.style;
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: "\n        ".concat(styles["innerContainer"], "\n        ").concat(styles["selected"]),
    style: style
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: styles["filename"]
  }, name + ".js"), /*#__PURE__*/_react["default"].createElement("div", {
    className: styles["dragBtn"]
  }, /*#__PURE__*/_react["default"].createElement(_icons.DragIndicatorIcon, null)), /*#__PURE__*/_react["default"].createElement("div", {
    className: styles["closeBtn"]
  }, /*#__PURE__*/_react["default"].createElement(_icons.CloseIcon, null)));
}

function InteractiveFileBlock(_ref2) {
  var name = _ref2.name,
      onDrag = _ref2.onDrag,
      onTargeted = _ref2.onTargeted;

  var _useState = (0, _react.useState)(initialRenameState),
      _useState2 = _slicedToArray(_useState, 2),
      _rename = _useState2[0],
      setRename = _useState2[1];

  var _files = (0, _reactRedux.useSelector)(function (state) {
    return state.files.container;
  });

  var _current = (0, _reactRedux.useSelector)(function (state) {
    return state.files.current;
  });

  var _drag = (0, _reactRedux.useSelector)(function (state) {
    return state.drag;
  });

  var dispatch = (0, _reactRedux.useDispatch)();
  var names = ["App"].concat(Object.keys(_files));

  var isDynamic = function isDynamic(name) {
    return name !== "App" && name === _current;
  };

  var isTargeted = function isTargeted(name) {
    return _drag.to === name;
  };

  var removeFile = function removeFile(name) {
    return dispatch((0, _fileSlice.remove)(name));
  };

  var viewFile = function viewFile(name) {
    return dispatch((0, _fileSlice.view)(name));
  };

  var updateFileState = function updateFileState(name) {
    if (isDynamic(name)) {
      return setRename({
        target: _current,
        name: _current
      });
    }

    viewFile(name);
  };

  var updateNewName = function updateNewName(e) {
    setRename(_objectSpread(_objectSpread({}, _rename), {}, {
      name: e.target.value
    }));
  };

  var finishRename = function finishRename() {
    var name = _rename.name;

    if (name !== _current) {
      name = (0, _file.genUniqueName)(names, name);
    }

    setRename(initialRenameState);
    dispatch((0, _fileSlice.rename)(name));
  };

  return /*#__PURE__*/_react["default"].createElement("div", {
    key: name,
    onMouseOver: name !== "App" && _drag.from ? function () {
      return onTargeted(name);
    } : undefined,
    className: "".concat(styles["innerContainer"]).concat(isTargeted(name) ? " " + styles["targeted"] : "").concat(_current === name ? " " + styles["selected"] : "")
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: styles["filename"],
    onClick: function onClick() {
      return updateFileState(name);
    }
  }, _current === name && _rename.target ? /*#__PURE__*/_react["default"].createElement("div", {
    className: styles["renameInputContainer"]
  }, /*#__PURE__*/_react["default"].createElement("input", {
    value: _rename.name,
    onChange: updateNewName,
    onBlur: finishRename,
    size: 1,
    type: "text",
    autoFocus: true
  }), /*#__PURE__*/_react["default"].createElement("span", {
    "data-value": _rename.name
  }, ".js")) : name + ".js"), name !== "App" && /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement("div", {
    className: styles["dragBtn"],
    onMouseDown: isDynamic(name) ? function (event) {
      return onDrag(event, name);
    } : undefined
  }, /*#__PURE__*/_react["default"].createElement(_icons.DragIndicatorIcon, null)), /*#__PURE__*/_react["default"].createElement("div", {
    className: styles["closeBtn"],
    onClick: function onClick() {
      return removeFile(name);
    }
  }, /*#__PURE__*/_react["default"].createElement(_icons.CloseIcon, null))));
}
//# sourceMappingURL=FileBlock.js.map
