"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactRedux = require("react-redux");

var _file = require("../../utilities/file");

var _fileSlice = require("../../store/fileSlice");

var _dragSlice = require("../../store/dragSlice");

var _icons = require("../icons");

var _FileBlock = require("./FileBlock");

var __styles = _interopRequireWildcard(require("./FileList.module.css"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var styles = __styles["default"] ? __styles["default"] : __styles;

function FileList() {
  var _useState = (0, _react.useState)(),
      _useState2 = _slicedToArray(_useState, 2),
      ShadowElement = _useState2[0],
      setShadowElement = _useState2[1];

  var _files = (0, _reactRedux.useSelector)(function (state) {
    return state.files.container;
  });

  var _drag = (0, _reactRedux.useSelector)(function (state) {
    return state.drag;
  });

  var names = ["App"].concat(Object.keys(_files));
  var dispatch = (0, _reactRedux.useDispatch)();

  var addFile = function addFile() {
    var counts = names.length + 1;
    var name = (0, _file.genUniqueName)(names, "Component".concat(counts));
    dispatch((0, _fileSlice.add)(name));
  };

  var generateShadow = function generateShadow(name, x, y) {
    var style = {};
    style.position = "absolute";
    style.top = y + 5 + "px";
    style.left = x + 5 + "px";
    style.zIndex = 100;
    style.opacity = 0.5;
    setShadowElement( /*#__PURE__*/_react["default"].createElement(_FileBlock.StaticFileBlock, {
      name: name,
      style: style
    }));
  };

  var selectCell = function selectCell(event, name) {
    var clientX = event.clientX,
        clientY = event.clientY;
    generateShadow(name, clientX, clientY);
    dispatch((0, _dragSlice.select)(name));
  };

  var targetCell = function targetCell(name) {
    return dispatch((0, _dragSlice.target)(name));
  };

  var dragCell = function dragCell(event) {
    var from = _drag.from;

    if (from) {
      var _target = event.target,
          clientX = event.clientX,
          clientY = event.clientY;
      generateShadow(from, clientX, clientY); // outside of the file container

      if (_target.id === styles["screenMask"]) {
        return dispatch((0, _dragSlice.untarget)());
      }
    }
  };

  var applyDrag = function applyDrag() {
    var from = _drag.from,
        to = _drag.to;

    if (from) {
      resetListener();
      setShadowElement(undefined);

      if (to) {
        dispatch((0, _fileSlice.swap)({
          from: from,
          to: to
        }));
      }

      dispatch((0, _dragSlice.reset)());
    }
  };

  var resetListener = function resetListener() {
    document.body.removeEventListener("mousemove", dragCell);
    document.body.removeEventListener("mouseup", applyDrag);
  };

  (0, _react.useEffect)(function () {
    var from = _drag.from;

    if (from) {
      document.body.addEventListener("mousemove", dragCell);
      document.body.addEventListener("mouseup", applyDrag);
      return function () {
        resetListener();
      };
    } // eslint-disable-next-line react-hooks/exhaustive-deps

  }, [_drag]);
  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement("div", {
    id: styles["filenameContainer"]
  }, names.map(function (name) {
    return /*#__PURE__*/_react["default"].createElement(_FileBlock.InteractiveFileBlock, {
      key: name,
      name: name,
      onDrag: selectCell,
      onTargeted: targetCell
    });
  }), /*#__PURE__*/_react["default"].createElement("div", {
    className: styles["innerContainer"],
    onClick: addFile
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: styles["addBtn"]
  }, /*#__PURE__*/_react["default"].createElement(_icons.PlusIcon, null)))), ShadowElement, _drag.from && /*#__PURE__*/_react["default"].createElement("div", {
    id: styles["screenMask"]
  }));
}

var _default = FileList;
exports["default"] = _default;
//# sourceMappingURL=FileList.js.map
