"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.untarget = exports.unselect = exports.select = exports.target = exports.reset = void 0;

var _toolkit = require("@reduxjs/toolkit");

var initialState = {};
var dragSlice = (0, _toolkit.createSlice)({
  name: "drag",
  initialState: initialState,
  reducers: {
    reset: function reset(state) {
      delete state.from;
      delete state.to;
    },
    target: function target(state, action) {
      state.to = action.payload;
    },
    select: function select(state, action) {
      state.from = action.payload;
    },
    unselect: function unselect(state) {
      delete state.to;
    },
    untarget: function untarget(state) {
      delete state.to;
    }
  }
});
var _dragSlice$actions = dragSlice.actions,
    reset = _dragSlice$actions.reset,
    target = _dragSlice$actions.target,
    select = _dragSlice$actions.select,
    unselect = _dragSlice$actions.unselect,
    untarget = _dragSlice$actions.untarget;
exports.untarget = untarget;
exports.unselect = unselect;
exports.select = select;
exports.target = target;
exports.reset = reset;
var _default = dragSlice.reducer;
exports["default"] = _default;
//# sourceMappingURL=dragSlice.js.map
