"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.edit = exports.view = exports.swap = exports.add = exports.remove = exports.rename = exports.init = void 0;

var _toolkit = require("@reduxjs/toolkit");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var initialState = {
  container: {},
  current: "App"
};
var fileSlice = (0, _toolkit.createSlice)({
  name: "file",
  initialState: initialState,
  reducers: {
    init: function init(state, action) {
      var _action$payload = action.payload,
          container = _action$payload.container,
          current = _action$payload.current;
      state.container = container;
      state.current = current;
    },
    rename: function rename(state, action) {
      var current = state.current,
          container = state.container;
      var fileName = action.payload;
      var names = Object.keys(state.container);
      var newContainer = {};
      names.forEach(function (name) {
        var newName = name === current ? fileName : name;
        newContainer[newName] = container[name];
      });
      state.container = newContainer;
      state.current = fileName;
    },
    remove: function remove(state, action) {
      var current = state.current,
          container = state.container;
      var fileName = action.payload;
      var newCurrent = current;

      if (fileName === newCurrent) {
        newCurrent = "App";
      }

      var newContainer = _objectSpread({}, container);

      delete newContainer[fileName];
      state.container = newContainer;
      state.current = newCurrent;
    },
    add: function add(state, action) {
      var container = state.container;
      var fileName = action.payload;

      var newContainer = _objectSpread(_objectSpread({}, container), {}, _defineProperty({}, fileName, ""));

      state.container = newContainer;
      state.current = fileName;
    },
    swap: function swap(state, action) {
      var container = state.container;
      var _action$payload2 = action.payload,
          from = _action$payload2.from,
          to = _action$payload2.to;
      var names = Object.keys(container);
      var newContainer = {};
      names.forEach(function (name) {
        if (name === from) name = to;else if (name === to) name = from;
        newContainer[name] = container[name];
      });
      state.container = newContainer;
    },
    view: function view(state, action) {
      state.current = action.payload;
    },
    edit: function edit(state, action) {
      var current = state.current;
      state.container[current] = action.payload;
    }
  }
});
var _fileSlice$actions = fileSlice.actions,
    init = _fileSlice$actions.init,
    rename = _fileSlice$actions.rename,
    remove = _fileSlice$actions.remove,
    add = _fileSlice$actions.add,
    swap = _fileSlice$actions.swap,
    view = _fileSlice$actions.view,
    edit = _fileSlice$actions.edit;
exports.edit = edit;
exports.view = view;
exports.swap = swap;
exports.add = add;
exports.remove = remove;
exports.rename = rename;
exports.init = init;
var _default = fileSlice.reducer;
exports["default"] = _default;
//# sourceMappingURL=fileSlice.js.map
